if [ $# -ne 3 ] && [ $# -ne 4 ]; then
    echo "Usage: $0 filename [1|2|3] outFile [logFile]" 
    exit
fi

FILE=$1
MODEL=$2
OUT=$3
if [ $# -eq 4 ]; then
    LOG=$4
else
    LOG="/dev/null/"
fi

echo "=== Decoding from $FILE using DP model $MODEL ==="

while read line; do
    echo "Decoding $line..."
    ./runDPDecoder.sh $MODEL "$line" 20 >> $OUT 2>> $LOG
done < $FILE