

class Model1Training {
    
    public static void main(String [] args) {
        if(args.length != 4) {
            System.out.println("usage: java Model1Training sourceCorpusFile destCorpusFile iters outFile");
            return;
        }
        for(String test : args)
            System.out.println(test);
        System.out.println("All done.");
        
        String sourceTextFile = args[0];
        String destTextFile = args[1];
        int numIters = Integer.parseInt(args[2]);
        String outTextFile = args[3];
        
        ParametersFromTextFile params = new ParametersFromTextFile();
        CorpusFromTextPair corpus = new CorpusFromTextPair(sourceTextFile, destTextFile);

        Model1 model1 = new Model1();

        model1.initialize(params, corpus);
        model1.train(params, corpus, numIters);
        params.exportParams(outTextFile);
    }
}
