
//TODO FIXME: test this!

class Model2Training {
    
    public static void main(String [] args) {
        if(args.length != 5) {
            System.out.println("usage: java Model2Training inFile sourceCorpusFile destCorpusFile iters outFile");
            return;
        }
        for(String test : args)
            System.out.println(test);
        System.out.println("All done.");
        
        // process command-line arguments
        String inTextFile = args[0];
        String sourceTextFile = args[1];
        String destTextFile = args[2];
        int numIters = Integer.parseInt(args[3]);
        String outTextFile = args[4];
        
        // get input params and corpus
        ParametersFromTextFile params = new ParametersFromTextFile(inTextFile);
        CorpusFromTextPair corpus = new CorpusFromTextPair(sourceTextFile, destTextFile);

        Model2 model2 = new Model2();
        
        // train params and export to output file
        model2.initialize(params, corpus);
        model2.train(params, corpus, numIters);
        params.exportParams(outTextFile);
    }
}
