import java.util.*;


class Model3Params extends ParametersFromTextFile {
    private final double smoothingValue = 0.0;//1E-30;
    public Hashtable<String, Double> Ttotal;
    public Hashtable<String, Double> Ntotal; 
    
    public Model3Params(String fileName) {
	super(fileName);
	//
    }
    
    public Model3Params() {
	super();
    }

    public double getModel3T(String destWord, String sourceWord) {
	double result = getT(destWord, sourceWord);
	/*if (result == 0.0) {
	    System.out.println("returning a smoothed value");
	    return smoothingValue/Ttotal.get(sourceWord);
	}
	else {*/
	    return result;
	    //}
    }
    public double getModel3N(int fertility, String sourceWord) {
	double result = getN(fertility, sourceWord);
	/*if (result == 0.0) {
	    System.out.println("returning a smoothed value");	    
	    return smoothingValue/Ntotal.get(sourceWord);
	}
	else {*/
	    return result;
	    //}
    }
    public void testSums() {
	Hashtable<String, Double> tTotal = new Hashtable<String, Double>();
	Hashtable<String, Double> dTotal = new Hashtable<String, Double>();
	Hashtable<String, Double> aTotal = new Hashtable<String, Double>();
	Hashtable<String, Double> nTotal = new Hashtable<String, Double>();
	LinkedList<Hashtable<String, Double>> tables = new LinkedList<Hashtable<String, Double>>();
	tables.add(tTotal);
	tables.add(dTotal);
	tables.add(aTotal);
	tables.add(nTotal);

	Enumeration en;


	en = tableT.keys();
	while (en.hasMoreElements()) {
	    String key = (String) en.nextElement();
	    String[] splitKeys = key.split(" ");
	    double value = getModel3T(splitKeys[0], splitKeys[1]);
	    String sourceWord = splitKeys[1];
	    if (tTotal.containsKey(sourceWord)) { tTotal.put(sourceWord, tTotal.get(sourceWord)+value); }
	    else { tTotal.put(sourceWord, value); }
	}

	en = tableD.keys();
	while (en.hasMoreElements()) {
	    String key = (String) en.nextElement();
	    double value = tableD.get(key);
	    String[] splitKeys = key.split(" ");
	    String totalKey = splitKeys[1]+" "+splitKeys[2]+" "+splitKeys[3];
	    if (dTotal.containsKey(totalKey)) { dTotal.put(totalKey, dTotal.get(totalKey)+value); }
	    else { dTotal.put(totalKey, value); }
	}

	en = tableA.keys();
	while (en.hasMoreElements()) {
	    String key = (String) en.nextElement();
	    double value = tableA.get(key);
	    String[] splitKeys = key.split(" ");
	    String totalKey = splitKeys[1]+" "+splitKeys[2]+" "+splitKeys[3];
	    if (aTotal.containsKey(totalKey)) { aTotal.put(totalKey, aTotal.get(totalKey)+value); }
	    else { aTotal.put(totalKey, value); }
	}

	en = tableN.keys();
	while (en.hasMoreElements()) {
	    String key = (String) en.nextElement();
	    String[] splitKeys = key.split(" ");
	    double value = getModel3N(Integer.parseInt(splitKeys[0]), splitKeys[1]);
	    String sourceWord = splitKeys[1];
	    if (nTotal.containsKey(sourceWord)) { nTotal.put(sourceWord, nTotal.get(sourceWord)+value); }
	    else { nTotal.put(sourceWord, value); }
	}

	for (Hashtable<String, Double> ht : tables) {
	    System.out.println("==================");
	    en = ht.keys();
	    while (en.hasMoreElements()) {
		String key = (String) en.nextElement();
		double value = ht.get(key);
		if (Math.abs(1-value) > .00001) {
		    System.out.print(key+" ");	       
		    System.out.println(value);
		}
	    }
	}
    }

}