if [ $# -ne 2 ] && [ $# -ne 3 ]; then
    echo "Usage: $0 [1|2|3] outFile [logFile]" 
    exit
fi

FILE="../corpora/textpairs/humantests2.es"
MODEL=$1
OUT=$2

rm -f $OUT

if [ $# -eq 3 ]; then
    LOG=$3
    rm -f $LOG
else
    LOG="/dev/null/"
fi

echo "=== Decoding from $FILE using DP model $MODEL ==="

while read line; do
    echo "DECODING $line..." | tee -a $LOG
    ./runDPDecoder.sh $MODEL "$line" 1 >> $OUT 2>> $LOG
done < $FILE
